#include <htc.h>
#include "wait_time.h"
#include "max7219_sub.h"

#define		MAX_CE1		RA0
#define		MAX_CE2		RA1
#define		MAX_DATA	RA2
#define		MAX_CLK		RA3
#define		MAX_WAIT	5
#define		HI			0
#define		LO			1

extern unsigned char	min;
extern unsigned char	hour;
extern unsigned char	day;
extern unsigned char	mon;
extern unsigned char	year;

/*---------- MAX7219 PORT INIT ----------*/
void	max7219_port_init(void)
{
	MAX_CE1=HI;NOP();
	MAX_CE2=HI;NOP();
	MAX_DATA=LO;NOP();
	MAX_CLK=LO;NOP();
}
/*---------- MAX7219 DATA SUB ----------*/
void	max7219_data_sub(unsigned char data)
{
unsigned char i;

	for(i=0;i<8;i++){
		if((data & 0x80)==0x80){
			MAX_DATA=HI;NOP();
		}
		else{
			MAX_DATA=LO;NOP();
		}
		data=data << 1;
		wait_time(MAX_WAIT);
		MAX_CLK=HI;NOP();
		wait_time(MAX_WAIT);
		MAX_CLK=LO;NOP();
	}
}
/*---------- MAX7219 DATA OUT ----------*/
void	max7219_data_out(unsigned char ch,unsigned char addr,unsigned char data)
{
	switch(ch){
		case 0:	MAX_CE1=LO;NOP();break;
		case 1:	MAX_CE2=LO;NOP();break;
	}
	
	max7219_data_sub(addr);
	max7219_data_sub(data);
	max7219_port_init();
}
/*---------- MAX7219 ONDO DISP ----------*/
void	max7219_ondo(unsigned char ch,unsigned char fugo,unsigned int count)
{
unsigned char n0,n1,n2;	

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);
	
	if(fugo==1){
		max7219_data_out(ch,0x02,font[15]);
	}
	else{
		max7219_data_out(ch,0x02,0x00);
	}
	if(n2==0){
		max7219_data_out(ch,0x03,0x00);
	}
	else{
		max7219_data_out(ch,0x03,font[n2]);
	}
	max7219_data_out(ch,0x04,font[n1] | 0x80);
	max7219_data_out(ch,0x05,font[n0]);
}
/*--------- MAX7219 KIATU DISP ----------*/
void	max7219_kiatu(unsigned char ch,unsigned int count)
{
unsigned char n0,n1,n2,n3,n4;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);

	if(n4==0){
		max7219_data_out(ch,0x01,0x00);
	}
	else{
		max7219_data_out(ch,0x01,font[n4]);
	}
	max7219_data_out(ch,0x02,font[n3]);
	max7219_data_out(ch,0x03,font[n2]);
	max7219_data_out(ch,0x04,font[n1] | 0x80);
	max7219_data_out(ch,0x05,font[n0]);
}
/*---------- MAX7219 MODE DISP ----------*/
void	max7219_disp_mode(unsigned char no)
{
	switch(no){
		case 0:	max7219_data_out(1,0x01,0x00);
				max7219_data_out(1,0x02,0x00);
				max7219_data_out(1,0x03,0x00);
				max7219_data_out(1,0x04,0x00);
				max7219_data_out(1,0x05,0x00);
				max7219_data_out(1,0x06,font[13]);
				max7219_data_out(1,0x07,font[14]);
				max7219_data_out(1,0x08,0x00);

				max7219_data_out(0,0x01,0x00);
				max7219_data_out(0,0x02,0x00);
				max7219_data_out(0,0x03,0x00);
				max7219_data_out(0,0x04,0x00);
				max7219_data_out(0,0x05,0x00);
				max7219_data_out(0,0x06,font[10]);
				max7219_data_out(0,0x07,font[11]);
				max7219_data_out(0,0x08,font[12]);
				break;
		case 1:	max7219_data_out(1,0x01,0x00);
				max7219_data_out(1,0x02,0x00);
				max7219_data_out(1,0x03,0x00);
				max7219_data_out(1,0x04,0x00);
				max7219_data_out(1,0x05,0x00);
				max7219_data_out(1,0x06,font[13]);
				max7219_data_out(1,0x07,font[14]);
				max7219_data_out(1,0x08,0x00);

				max7219_data_out(0,0x01,0x00);
				max7219_data_out(0,0x02,0x00);
				max7219_data_out(0,0x03,0x00);
				max7219_data_out(0,0x04,0x00);
				max7219_data_out(0,0x05,0x00);
				max7219_data_out(0,0x06,font[16]);
				max7219_data_out(0,0x07,font[17]);
				max7219_data_out(0,0x08,0x00);
				break;
		case 2:
		case 4:
		case 3:	max7219_data_out(1,0x01,0x00);
				max7219_data_out(1,0x02,0x00);
				max7219_data_out(1,0x03,0x00);
				max7219_data_out(1,0x04,0x00);
				max7219_data_out(1,0x05,0x00);
				max7219_data_out(1,0x06,font[13]);
				max7219_data_out(1,0x07,font[14]);
				max7219_data_out(1,0x08,0x00);

				max7219_data_out(0,0x01,0x00);
				max7219_data_out(0,0x02,0x00);
				max7219_data_out(0,0x03,0x00);
				max7219_data_out(0,0x04,0x00);
				max7219_data_out(0,0x05,0x00);
				max7219_data_out(0,0x06,0x00);
				max7219_data_out(0,0x07,0x00);
				max7219_data_out(0,0x08,0x00);
				break;
	}
}
/*----------- MAX7219 SITUDO DISP ----------*/
void	max7219_situdo(unsigned char ch,unsigned char count)
{
unsigned char n0,n1;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);

	max7219_data_out(ch,0x03,font[n1]);
	max7219_data_out(ch,0x04,font[n0]);
}
/*---------- MAX7219 TIME ----------*/
void	max7219_time(unsigned char ch)
{
unsigned char n0,n1,n2,n3;

	n3=hour&0xf0;n3=n3 >> 4;
	n2=hour&0x0f;
	n1=min&0xf0;n1=n1 >> 4;
	n0=min&0x0f;

	max7219_data_out(ch,0x03,font[n3]);
	max7219_data_out(ch,0x04,font[n2] | 0x80);
	max7219_data_out(ch,0x05,font[n1]);
	max7219_data_out(ch,0x06,font[n0]);
}
/*---------- MAX7219 DATE ----------*/
void	max7219_date(unsigned char ch)
{
unsigned char n0,n1,n2,n3,n4,n5;
	
	n5=year&0xf0;n5=n5 >> 4;
	n4=year&0x0f;
	n3=mon&0xf0;n3=n3 >> 4;
	n2=mon&0x0f;
	n1=day&0xf0;n1=n1 >> 4;
	n0=day&0x0f;

	max7219_data_out(ch,0x01,font[2]);
	max7219_data_out(ch,0x02,font[0]);
	max7219_data_out(ch,0x03,font[n5]);
	max7219_data_out(ch,0x04,font[n4] | 0x80);
	max7219_data_out(ch,0x05,font[n3]);
	max7219_data_out(ch,0x06,font[n2] | 0x80);
	max7219_data_out(ch,0x07,font[n1]);
	max7219_data_out(ch,0x08,font[n0]);
}
/*------------ MAX7219 DATE TIME --------------*/
void	max7219_date_time(unsigned char ch)
{
unsigned char n0,n1,n2,n3,n4,n5,n6,n7;

	n7=mon&0xf0;n7=n7 >> 4;
	n6=mon&0x0f;
	n5=day&0xf0;n5=n5 >> 4;
	n4=day&0x0f;

	max7219_data_out(ch,0x01,font[n7]);
	max7219_data_out(ch,0x02,font[n6] | 0x80);
	max7219_data_out(ch,0x03,font[n5]);
	max7219_data_out(ch,0x04,font[n4] | 0x80);

	n3=hour&0xf0;n3=n3 >> 4;
	n2=hour&0x0f;
	n1=min&0xf0;n1=n1 >> 4;
	n0=min&0x0f;

	max7219_data_out(ch,0x05,font[n3]);
	max7219_data_out(ch,0x06,font[n2] | 0x80);
	max7219_data_out(ch,0x07,font[n1]);
	max7219_data_out(ch,0x08,font[n0]);
}